import logger;
import std.date;
import std.stdio;
import std.conv;
import core.thread;
import std.functional;

static const uint MaxRecs = 10_000;
static Logger lgr;

static string filename = "test.log";
//alias curry!(simpleLogger, filename) simpleWrite;
void simpleWriter()
{
    simpleLogger(filename);
    //simpleLogger();
}

void benchLog()
{
    try
    {
        writeln("Benchmarking first logger.");
        Logger lgr = new Logger(__FILE__, &simpleWriter);
        for (uint i; i < MaxRecs; i++)
        {
            lgr.trace("Current i: " ~ to!(string)(i));
        }
    }
    catch(Exception e)
    {
        writeln("Benchlog: ", e.msg);
    }
}

void benchLog2()
{
    try
    {
        writeln("Benchmarking second logger.");
        Logger lgr = new Logger(__FILE__, &simpleWriter, true);
        for (uint i; i < MaxRecs; i++)
        {
            lgr.trace("Current i: " ~ to!(string)(i));
        }
    }
    catch(Exception e)
    {
        writeln("Benchlog2: ", e.msg);
    }
}

void benchThreads()
{
    writeln("Benchmarking threads.");
    Thread thread1 = new Thread(&thr1);
    Thread thread2 = new Thread(&thr2);
    thread1.start();
    thread2.start();
    thread1.join();
    thread2.join();
}

void benchNoLog()
{
    writeln("Benchmarking no logger.");
    for (uint i; i < MaxRecs; i++)
    {
    }
}

void thr1()
{
    try
    {
        writeln("In thread 1.");
        Logger llgr = new Logger(__FILE__ ~ ": thread 1");
        writeln("Thread 1 - starting to loop.");
        for (uint i; i < MaxRecs; i++)
        {
            llgr.trace("Thread 1 - Current i: " ~ to!(string)(i));
        }
    }
    catch(Exception e)
    {
        writeln("Thread1: ", e.msg);
    }
}

void thr2()
{
    try
    {
        writeln("In thread 2.");
        Logger llgr = new Logger(__FILE__ ~ ": thread 2");
        writeln("Thread 2 - starting to loop.");
        for (uint i; i < MaxRecs; i++)
        {
            llgr.trace("Thread 2 - Current i: " ~ to!(string)(i));
        }
    }
    catch(Exception e)
    {
        writeln("Thread2: ", e.msg);
    }
}

void main()
{
    try
    {
        lgr = new Logger(__FILE__, &simpleWriter);
        writeln("Time: ", benchmark!(benchLog, benchLog2, benchThreads, benchNoLog)(1));
    }
    catch(Exception e)
    {
        writeln("In benchmark file: ", e.msg);
    }
}
